extends Sprite2D

@export var fog_width : int
@export var fog_height : int
var fog_image : Image
var fog_texture : ImageTexture

var current_image : Image
var current_texture : ImageTexture

@export var light_texture : Texture2D
var light_image : Image

@export var player : CharacterBody2D

func _ready() -> void:
	fog_image = Image.create(fog_width, fog_height, false, Image.FORMAT_RGBA8)
	fog_image.fill(Color.WHITE)
	fog_texture = ImageTexture.create_from_image(fog_image)
	texture = fog_texture
	
	current_image = fog_image.duplicate()
	current_texture = fog_texture.duplicate()
	material.set_shader_parameter("current_texture", current_texture)
	
	light_image = light_texture.get_image()
	
	update_fog()
	
func _process(delta: float) -> void:
	if player.velocity != Vector2.ZERO:
		update_fog()

func update_fog():
	var player_position = player.global_position + Vector2(fog_width, fog_height) / 2
	player_position -= Vector2(light_image.get_size()) / 2
	fog_image.blend_rect(light_image, Rect2i(Vector2.ZERO, light_image.get_size()), player_position)
	fog_texture.update(fog_image)
	
	current_image.fill(Color.WHITE)
	current_image.blend_rect(light_image, Rect2i(Vector2.ZERO, light_image.get_size()), player_position)
	current_texture.update(current_image)
	
